<template>
  <div>
    <b-container>

      <b-row class="justify-content-md-center ">
        <b-col cols="6">
          <div class ="margin-l-4">
            <label for="cups">
              Write your CUPS code to check your status and see the offers available:
            </label>
            <div class="col-11 mt-2" style="display:inline-flex;">
              <b-form-input class="mr-2" v-model="cupsCode" placeholder="Enter your CUPS" @keyup.enter="search()">
              </b-form-input>
              <b-button id="searchBtn" class="btn-primary float-end" :disabled="searchBtnDisabled" @click="search()">
                Search</b-button>
            </div>
          </div>

          <div v-if="clientToDisplay" class="pt-3">
            <div class="card">
              <h3>Client info:</h3>
              <p>Full name: {{ clientToDisplay.full_name }}</p>
              <p>Address: {{ clientToDisplay.address }} </p>
              <p>Building type: {{ clientToDisplay.building_type }}</p>
            </div>

            <div v-if="supplyPointToDisplay">
              <div class="card">

                <h3>Client supply point info:</h3>
                <p>Tariff: {{ supplyPointToDisplay.tariff }}</p>
                <p>Invoiced amount: {{ supplyPointToDisplay.invoiced_amount }} €</p>
                <p>Power:

                <ul>
                  <li>P1: {{ supplyPointToDisplay.power?.p1 }}</li>
                  <li>P2: {{ supplyPointToDisplay.power?.p2 }}</li>
                </ul>
                </p>
                <p>Neighbors nº: {{ supplyPointToDisplay.neighbors?.length }}</p>
              </div>

              <div v-if="isClientAllowedToEnrollRooftopRevolution(clientToDisplay)">
                <div class="card">
                  <h3>Available offer:</h3>
                  <ul>
                    <li v-if="offerAvailableForTheClientToDisplay === offersType[0]">Standard offer: standard offer with
                      no discount</li>
                    <li v-if="offerAvailableForTheClientToDisplay === offersType[1]">Basic discount: 5% discount
                      {{ supplyPointToDisplay.power?.p2 }}</li>
                    <li v-if="offerAvailableForTheClientToDisplay === offersType[2]">Special discount: 12%
                      discount{{ supplyPointToDisplay.power?.p2 }}</li>
                  </ul>
                </div>
              </div>
              <div v-else class="error">
                <p>
                  No offer available for this user
                </p>
              </div>

            </div>
            <div v-else class="error margin-l-4">
              <p>
                Can't find supply point data for this user
              </p>
            </div>
          </div>

          <div v-if="!clientToDisplay && searchExecuted">
            <p class="error margin-l-4">No client found with the CUPS code entered</p>
          </div>

        </b-col>
      </b-row>
    </b-container>
  </div>
</template>

<script>
import * as fetchers from '@/services/fetchers'

export default {
  name: "RooftopRevolution",
  data() {
    return {
      cupsCode: "", // cupsCode used in search bar
      searchExecuted: false, //indicate if the search has been triggered at least 1 time
      clients: null, // array of clients retrieved from the DB
      clientToDisplay: null, // the client that is displayed after the search
      supplyPoints: null, // array with all the supply points rerieved from the DB
      supplyPointToDisplay: null, // the suppli point data of the client displayed
      offersType: ['standard', 'basic', 'special'], // array of offers available
      offerAvailableForTheClientToDisplay: null, // filled with the offer available for the displayde user. The offer available is one of the offersType array
    };
  },
  computed: {
    searchBtnDisabled() {
      return this.cupsCode.length == 0;
    }
  },
  methods: {
    /**
     * Search a client by CUPS code, retieve his informations, and calculate the available offers
     */
    async search() {
      await this.setClientToDisplayByCupsCode();
      await this.setSupplyPointToDisplay();
      this.calculateAvailableDiscountsForDisplayedUser();
      this.searchExecuted = true;
    },
    /**
     * Retrieve all the clients from the DB and set the client to display filtering the results by the unique CUPS code.
     */

    //TODO: develop a rest service 'getClientByCupsCode' and move the filter logic on BE side
    async setClientToDisplayByCupsCode() {
      await this.setClients();
      const matchingClient = Object.values(this.clients).find((client) => {
        return this.cupsCode.trim().toUpperCase() == client.cups?.trim().toUpperCase()
      });

      this.clientToDisplay = matchingClient;
    },
    /**
    * Calls a rest service to retrieve all the clients from the database and set them in the controller. 
    * The rest endopint is called only if supplyPoints haven't been retrieved yet
    */
    async setClients() {
      if (!this.clients) {
        const response = await fetchers.getClients();
        this.clients = response?.data;
      }
    },
    /**
    * Calls a rest service to retrieve all the supplyPoints from the database and set them in the controller. 
    * The rest endopint is called only if supplyPoints haven't been retrieved yet
    */
    async setSupplyPoints() {
      if (!this.supplyPoints) {
        const response = await fetchers.getSupplyPoints();
        this.supplyPoints = response?.data;
      }
    },
    /**
     * Filters between all the supply points retrieved from the backend and search for the user supply point using the cups code.
     * Once found sets the supply point to display in the data model
     */
    async setSupplyPointToDisplay() {
      if (this.clientToDisplay) {
        await this.setSupplyPoints();
        const matchingClientSupplyPoint = this.getClientSupplyPointByCupsCode(this.clientToDisplay.cups);
        this.supplyPointToDisplay = matchingClientSupplyPoint;
      }
    },
    /**
     * Return the client supply point from the supply points array using the cupsCode property
     * @param {*} cupsCode user cupsCode used to search the supply point 
     */
    getClientSupplyPointByCupsCode(cupsCode) {
      return Object.values(this.supplyPoints).find(supplyPoint => supplyPoint.cups?.trim().toUpperCase() == cupsCode.trim().toUpperCase());
    },
    /**
     * Cheks if a client is allowed or not to entroll to the rooftop revolution products
     * @param {*} client client to check 
     */
    isClientAllowedToEnrollRooftopRevolution(client) {
      const buildingTypeAllowed = "house"; // building type required to be allowed to get enrolled with the rooftop revolution
      const minNeighborNumber = 1; // neighbor number needed in orter to be allowed to get enrolled with the rooftop revolution

      return client.building_type == buildingTypeAllowed && this.supplyPointToDisplay.neighbors?.length >= minNeighborNumber;
    },
    /**
     * Calculate to which discount the displayed user has access
     */
    calculateAvailableDiscountsForDisplayedUser() {
      if (this.clientToDisplay && this.isClientAllowedToEnrollRooftopRevolution(this.clientToDisplay)) {
        const userNeighborsCapsCodes = this.supplyPointToDisplay?.neighbors;
        let userNeighbors = [];
        userNeighborsCapsCodes.forEach(capsCode => {
          userNeighbors.push(this.getClientSupplyPointByCupsCode(capsCode));
        });

        if (this.userAvailableForSpecialDiscount(this.supplyPointToDisplay, userNeighbors)) { this.offerAvailableForTheClientToDisplay = this.offersType[2] }
        else if (this.userAvailableForBasicDiscount(this.supplyPointToDisplay, userNeighbors)) { this.offerAvailableForTheClientToDisplay = this.offersType[1] }
        else { this.offerAvailableForTheClientToDisplay = this.offersType[0] }
      } else {
        this.offerAvailableForTheClientToDisplay = null;
      }
    },
    /**
     * Checks if the user is available for a basic discount.
     * To to access the basic discount the userd should have at least 1 neighbor with p1 and p2 power lower than his p1 and p2 power
     * @param {*} userSupplyPoint the supply object of the user on which check the availability of the discount
     * @param {*} neighborsArray the array of neighbors from wich retrieve the power
     */
    userAvailableForBasicDiscount(userSupplyPoint, neighborsArray) {
      if (userSupplyPoint && neighborsArray?.length > 0) {
        const neighborWithLowerPower = Object.values(neighborsArray).find(neighbor => neighbor.power?.p1 < userSupplyPoint.power.p1 && neighbor.power?.p2 < userSupplyPoint.power.p2);
        const neighborWithLowerPowerFound = neighborWithLowerPower ? true : false;
        return neighborWithLowerPowerFound;
      }
    },
    /**
     * Checks if the user is available for the special discount.
     * To be able to acces to the special discount the addition of the `invoiced_amount` of its neighbors should be more than 100 euros
     * @param {*} userSupplyPoint the supply object of the user from on which check the availability of the discount
     * @param {*} neighborsArray the array of neighbors from wich calculate the invoice amount
     */
    userAvailableForSpecialDiscount(userSupplyPoint, neighborsArray) {
      if (userSupplyPoint && neighborsArray?.length > 0) {
        const amountToReachTheDiscount = 100;
        const neighborsInvoiceTotalAmount = neighborsArray.map(neighbor => neighbor.invoiced_amount).reduce((totalAmount, neighborAmount) => parseInt(totalAmount) + parseInt(neighborAmount));
        console.log('neighborsInvoiceTotalAmount', neighborsInvoiceTotalAmount)
        return neighborsInvoiceTotalAmount > amountToReachTheDiscount;
      }
    }
  }
};
</script>

<style scoped>
#searchBtn {
  margin-left: 2%;
}

.margin-l-4{
  margin-left:4%;
}
</style>